| kspaceFirstOrder3D-OMP 1.0 The C++ implementation of the k-wave toolbox for the time-domain simulation of acoustic wave fields in 3D

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions
TComplexMatrix Class Reference

The class for complex matrices.

`#include <ComplexMatrix.h>`

Inheritance diagram for TComplexMatrix:
[legend]
Collaboration diagram for TComplexMatrix:
[legend]

List of all members.

## Public Member Functions
| TComplexMatrix (struct TDimensionSizes DimensionSizes)
| Constructor.
virtual | ~TComplexMatrix ()
| Destructor.
TFloatComplex & | operator[] (const size_t &index)
| operator []
const TFloatComplex & | GetElementFrom3D (const size_t X, const size_t Y, const size_t Z)
| Get element from 3D matrix.
virtual void | ReadDataFromHDF5File (THDF5_File &HDF5_File, const char *MatrixName)
| Load data from the HDF5_File.
virtual void | WriteDataToHDF5File (THDF5_File &HDF5_File, const char *MatrixName, const int CompressionLevel)
| Write data into the HDF5_File.
## Protected Member Functions
| TComplexMatrix ()
| Default constructor not allowed for public.
| TComplexMatrix (const TComplexMatrix &src)
| Copy constructor not allowed for public.
TComplexMatrix & | operator= (const TComplexMatrix &src)
| Operator not allowed for public.
virtual void | InitDimensions (struct TDimensionSizes DimensionSizes)
| Initialize dimension sizes and related structures.

## Detailed Description

Definition at line 62 of file ComplexMatrix.h.

## Constructor & Destructor Documentation

TComplexMatrix::TComplexMatrix | ( | struct TDimensionSizes | DimensionSizes | ) |

Constructor

Parameters:

  [in] | DimensionSizes | - Dimension sizes

Definition at line 56 of file ComplexMatrix.cpp.

Here is the call graph for this function:

## Member Function Documentation

const TFloatComplex& TComplexMatrix::GetElementFrom3D | ( | const size_t | X,
|  | const size_t | Y,
|  | const size_t | Z
| ) |  | `[inline]`

Parameters:

  X | - X dimension
  Y | - Y dimension
  Z | - Z dimension

Returns:
  a complex element of the class

Definition at line 89 of file ComplexMatrix.h.

void TComplexMatrix::InitDimensions | ( | struct TDimensionSizes | DimensionSizes | ) | `[protected, virtual]`

Initialize matrix dimension sizes.

Parameters:

  DimensionSizes |

Definition at line 108 of file ComplexMatrix.cpp.

Here is the caller graph for this function:

TFloatComplex& TComplexMatrix::operator[] | ( | const size_t & | index | ) | `[inline]`

Parameters:

  index | - 1D index into the array

Returns:
  - element of the matrix

Definition at line 77 of file ComplexMatrix.h.

void TComplexMatrix::ReadDataFromHDF5File | ( | THDF5_File & | HDF5_File,
|  | const char * | MatrixName
| ) |  | `[virtual]`

Read data from HDF5 file (do some basic checks).

Exceptions:

  ios::failure | when there is a problem

Parameters:

  [in] | HDF5_File | - HDF5 file
  [in] | MatrixName | - HDF5 dataset name

Reimplemented from TBaseMatrix.

Definition at line 74 of file ComplexMatrix.cpp.

Here is the call graph for this function:

void TComplexMatrix::WriteDataToHDF5File | ( | THDF5_File & | HDF5_File,
|  | const char * | MatrixName,
|  | const int | CompressionLevel
| ) |  | `[virtual]`

Write data to HDF5 file

Exceptions:

  an | exception what the operaion fails

Parameters:

  HDF5_File | - HDF5 file hande
  MatrixName | - HDF5 dataset name
  CompressionLevel | - Compression level for the dataset

Reimplemented from TBaseMatrix.

Definition at line 138 of file ComplexMatrix.cpp.

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- MatrixClasses/ComplexMatrix.h
- MatrixClasses/ComplexMatrix.cpp

All Classes Files Functions Variables Typedefs Enumerations